<template>
  <div id="users">
    <coscine-headline :headline="$t('userListHeadline')" />
    <div class="UserList">
      <b-container>
        <div class="user-complete-name-list">
          <span v-for="(projectRole, index) in sortedProjectRoles" :key="index">
            <b-row class="user-field">
              <b-col sm="2">
                <img class="user-image" :src="alumniImage" alt />
              </b-col>
              <b-col sm="8" class="user-details">
                {{ projectRole.user.displayName }}
                <br />
                <a
                  v-b-tooltip.hover.bottom="projectRole.user.emailAddress"
                  :href="'mailto:' + projectRole.user.emailAddress"
                >
                  {{ projectRole.user.emailAddress }}
                </a>
              </b-col>
              <b-col sm="2">
                <b-button
                  id="leave"
                  class="float-right"
                  variant="primary"
                  name="leave"
                  v-if="projectRole.user.id === currentUser.id"
                  v-on:click="openLeaveModal()"
                  :disabled="leaveDisabled"
                  tabindex="0"
                  v-b-popover.hover.bottom
                  :title="leaveDisabled ? $t('disabledPopover') : $t('popover')"
                  >{{ $t("leaveButton") }}</b-button
                >
              </b-col>
            </b-row>
          </span>
        </div>
        <span v-if="isOwner">
          <b-row>
            <b-col sm="12" class="manage-users-link">
              <a :href="usersManagementLink">{{
                $t("userManagementLinkText")
              }}</a>
            </b-col>
          </b-row>
        </span>
      </b-container>
      <b-modal
        id="leaveModal"
        hide-footer
        :title="
          $t('leaveTitle1') + this.project.displayName + $t('leaveTitle2')
        "
        @shown="openedLeaveModal()"
      >
        <div>{{ $t("leave1") + this.project.displayName + $t("leave2") }}</div>
        <b-button
          class="float-right"
          variant="primary"
          v-on:click="closeLeaveModal()"
          ref="modalLeaveProjectCancel"
          autofocus
          >{{ $t("cancel") }}</b-button
        >
        <b-button
          class="float-Left"
          variant="danger"
          v-on:click="leaveProject()"
          >{{ $t("leave") }}</b-button
        >
      </b-modal>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { LinkUtil, GuidUtil } from "@coscine/app-util";
import { ProjectApi, ProjectRoleApi, UserApi } from "@coscine/api-client";
import {
  ProjectObject,
  ProjectRoleObject,
  RoleObject,
} from "@coscine/api-client/dist/types/Coscine.Api.Project";
import { UserObject } from "@coscine/api-client/dist/types/Coscine.Api.User";

import { CoscineHeadline } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import alumniImagePath from "./assets/RWTH_Piktogramm_Alumni_Square.png";

let pathToAppJs = "";
if (document.currentScript !== undefined) {
  pathToAppJs = (document.currentScript as any).src as string;
}
export default Vue.extend({
  name: "users",
  components: {
    CoscineHeadline,
  },
  created() {
    this.alumniImage = LinkUtil.getScriptPath(pathToAppJs) + alumniImagePath;
    this.projectId = GuidUtil.getProjectId();
    this.usersManagementLink = LinkUtil.getProjectLink("UserManagement");

    this.getUser();
    this.getProjectInformation();
    this.getProjectRoles();
  },
  data() {
    return {
      project: {} as ProjectObject,
      projectId: "",
      alumniImage: "",
      projectRoles: [] as ProjectRoleObject[],
      usersManagementLink: "",
      currentUser: {} as UserObject,
    };
  },
  computed: {
    currentUserRole(): RoleObject | null | undefined {
      const userProjectRole = this.projectRoles.find(
        (projectRole) =>
          projectRole.user && projectRole.user.id === this.currentUser.id
      );
      return userProjectRole ? userProjectRole.role : null;
    },
    isOwner(): boolean {
      return this.currentUserRole &&
        this.currentUserRole.displayName === "Owner"
        ? true
        : false;
    },
    leaveDisabled(): boolean {
      return this.ownerCount < 2 && this.isOwner;
    },
    ownerCount(): number {
      return this.projectRoles.filter(
        (projectRole) =>
          projectRole.role && projectRole.role.displayName === "Owner"
      ).length;
    },
    sortedProjectRoles(): ProjectRoleObject[] {
      // Copy project roles
      const sortedProjectRoles = [...this.projectRoles];
      sortedProjectRoles.sort((a, b) => {
        if (
          a.user !== null &&
          a.user !== undefined &&
          b.user !== null &&
          b.user !== undefined &&
          a.user.displayName !== null &&
          a.user.displayName !== undefined &&
          b.user.displayName !== null &&
          b.user.displayName !== undefined
        ) {
          const valueA = a.user.displayName.toUpperCase();
          const valueB = b.user.displayName.toUpperCase();
          return valueA < valueB ? -1 : valueA > valueB ? 1 : 0;
        } else {
          return 0;
        }
      });
      return sortedProjectRoles;
    },
  },
  methods: {
    async getProjectInformation() {
      const projectResponse = await ProjectApi.projectGet(this.projectId);
      this.project = projectResponse.data;
    },
    async getProjectRoles() {
      const projectRoleResponse = await ProjectRoleApi.projectRoleIndex(
        this.projectId
      );

      const projectRoles = projectRoleResponse.data;
      this.projectRoles = projectRoles;
    },
    async getUser() {
      const userResponse = await UserApi.userGetUser();
      this.currentUser = userResponse.data;
    },
    openLeaveModal() {
      this.$bvModal.show("leaveModal");
    },
    openedLeaveModal() {
      this.$nextTick(() => {
        (this.$refs.modalLeaveProjectCancel as any).focus();
      });
    },
    async leaveProject() {
      await ProjectRoleApi.projectRoleDelete2(this.projectId);
      LinkUtil.redirectToRoot();
    },
    closeLeaveModal() {
      this.$bvModal.hide("leaveModal");
    },
  },
});
</script>

<style scoped>
.user-image {
  width: 3em;
}
.user-details {
  text-align: left;
  margin-top: auto;
  margin-bottom: auto;
  padding-left: 1.5em;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  width: 90%;
}
.user-field {
  margin-bottom: 0.6em;
  margin-left: -5px;
}
.manage-users-link {
  text-align: left;
}
.manage-users-link a {
  margin-left: 10px;
}
.user-complete-name-list {
  max-height: 400px;
  overflow-x: hidden;
  overflow-y: auto;
}
#users {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}
#users h4 {
  color: #000;
  font-family: "Avenir", Helvetica, Arial, sans-serif;
}
.UserList #leave:hover {
  background-color: #9b0517;
  border-color: #8e0515;
  color: #ffffff;
}
</style>

<style>
.modal-backdrop {
  opacity: 0.5;
}
.modal-header .modal-title {
  margin-block-start: 0;
  margin-block-end: 0;
  margin-left: 0;
}
.modal-header button.close {
  text-align: end;
  min-width: 1em;
}
.modal .btn-primary {
  float: right;
  margin-right: 0;
  margin-bottom: 0;
  margin-top: 2em;
}
.modal .btn-danger {
  float: left;
  margin-left: 0;
  margin-bottom: 0;
  margin-top: 2em;
}
</style>
